bzlib-0.5.2.0: Compression and decompression in the bzip2 format

Copyright | (c) 2006-2008 Duncan Coutts
License | BSD-style
Maintainer | duncan@haskell.org
Stability | provisional
Portability | portable (H98 + FFI)
Safe Haskell | None
Language | Haskell2010

Codec.Compression.BZip.Internal

Contents

- Pure interface
- Monadic incremental interface
  - Incremental compression
  - Incremental decompression
- The compression parameter types

Description

Pure stream based interface to lower level bzlib wrapper

Synopsis

- compress :: CompressParams -> ByteString -> ByteString
- decompress :: DecompressParams -> ByteString -> ByteString
- data CompressStream (m :: Type -> Type)
  - = CompressInputRequired {
    - compressSupplyInput :: ByteString -> m (CompressStream m)
    }
  - | CompressOutputAvailable {
    - compressOutput :: !ByteString
    - compressNext :: m (CompressStream m)
    }
  - | CompressStreamEnd
- compressST :: CompressParams -> CompressStream (ST s)
- compressIO :: CompressParams -> CompressStream IO
- foldCompressStream :: Monad m => ((ByteString -> m a) -> m a) -> (ByteString -> m a -> m a) -> m a -> CompressStream m -> m a
- foldCompressStreamWithInput :: (ByteString -> a -> a) -> a -> (forall s. CompressStream (ST s)) -> ByteString -> a
- data DecompressStream (m :: Type -> Type)
  - = DecompressInputRequired {
    - decompressSupplyInput :: ByteString -> m (DecompressStream m)
    }
  - | DecompressOutputAvailable {
    - decompressOutput :: !ByteString
    - decompressNext :: m (DecompressStream m)
    }
  - | DecompressStreamEnd {
    - decompressUnconsumedInput :: ByteString
    }
  - | DecompressStreamError {
    - decompressStreamError :: DecompressError
    }
- decompressST :: DecompressParams -> DecompressStream (ST s)
- decompressIO :: DecompressParams -> DecompressStream IO
- foldDecompressStream :: Monad m => ((ByteString -> m a) -> m a) -> (ByteString -> m a -> m a) -> (ByteString -> m a) -> (DecompressError -> m a) -> DecompressStream m -> m a
- foldDecompressStreamWithInput :: (ByteString -> a -> a) -> (ByteString -> a) -> (DecompressError -> a) -> (forall s. DecompressStream (ST s)) -> ByteString -> a
- data CompressParams = CompressParams {
  - compressBlockSize :: BlockSize
  - compressWorkFactor :: WorkFactor
  - compressBufferSize :: Int
  }
- defaultCompressParams :: CompressParams
- data DecompressParams = DecompressParams {
  - decompressMemoryLevel :: MemoryLevel
  - decompressBufferSize :: Int
  }
- defaultDecompressParams :: DecompressParams
- data BlockSize
  - = DefaultBlockSize
  - | BlockSize Int
- data WorkFactor
  - = DefaultWorkFactor
  - | WorkFactor Int
- data MemoryLevel
  - = DefaultMemoryLevel
  - | MinMemoryLevel

# Pure interface

compress :: CompressParams -> ByteString -> ByteString Source #

decompress :: DecompressParams -> ByteString -> ByteString Source #

# Monadic incremental interface

## Incremental compression

data CompressStream (m :: Type -> Type) Source #

The unfolding of the compression process, where you provide a sequence of uncompressed data chunks as input and receive a sequence of compressed data chunks as output. The process is incremental, in that the demand for input and provision of output are interleaved.

Constructors

CompressInputRequired |

Fields

- compressSupplyInput :: ByteString -> m (CompressStream m)

CompressOutputAvailable |

Fields

- compressOutput :: !ByteString
- compressNext :: m (CompressStream m)

CompressStreamEnd |

compressST :: CompressParams -> CompressStream (ST s) Source #

compressIO :: CompressParams -> CompressStream IO Source #

foldCompressStream :: Monad m => ((ByteString -> m a) -> m a) -> (ByteString -> m a -> m a) -> m a -> CompressStream m -> m a Source #

A fold over the `CompressStream` in the given monad.

One way to look at this is that it runs the stream, using callback functions for the three stream events.

foldCompressStreamWithInput :: (ByteString -> a -> a) -> a -> (forall s. CompressStream (ST s)) -> ByteString -> a Source #

A variant on `foldCompressStream` that is pure rather than operating in a monad and where the input is provided by a lazy `ByteString`. So we only have to deal with the output and end parts, making it just like a foldr on a list of output chunks.

For example:

    toChunks = foldCompressStreamWithInput (:) []

## Incremental decompression

data DecompressStream (m :: Type -> Type) Source #

Constructors

DecompressInputRequired |

Fields

- decompressSupplyInput :: ByteString -> m (DecompressStream m)

DecompressOutputAvailable |

Fields

- decompressOutput :: !ByteString
- decompressNext :: m (DecompressStream m)

DecompressStreamEnd | Includes any trailing unconsumed input data.

Fields

- decompressUnconsumedInput :: ByteString

DecompressStreamError | An error code

Fields

- decompressStreamError :: DecompressError

decompressST :: DecompressParams -> DecompressStream (ST s) Source #

decompressIO :: DecompressParams -> DecompressStream IO Source #

foldDecompressStream :: Monad m => ((ByteString -> m a) -> m a) -> (ByteString -> m a -> m a) -> (ByteString -> m a) -> (DecompressError -> m a) -> DecompressStream m -> m a Source #

foldDecompressStreamWithInput :: (ByteString -> a -> a) -> (ByteString -> a) -> (DecompressError -> a) -> (forall s. DecompressStream (ST s)) -> ByteString -> a Source #

# The compression parameter types

data CompressParams Source #

The full set of parameters for compression. The defaults are `defaultCompressParams`.

The `compressBufferSize` is the size of the first output buffer containing the compressed data. If you know an approximate upper bound on the size of the compressed data then setting this parameter can save memory. The default compression output buffer size is `16k`. If your estimate is wrong it does not matter too much, the default buffer size will be used for the remaining chunks.

Constructors

CompressParams |

Fields

- compressBlockSize :: BlockSize
- compressWorkFactor :: WorkFactor
- compressBufferSize :: Int

#### Instances

Instances details

Show CompressParams Source # |
Instance details Defined in Codec.Compression.BZip.Internal Methods showsPrec :: Int -> CompressParams -> ShowS Source # show :: CompressParams -> String Source # showList :: [CompressParams] -> ShowS Source #

defaultCompressParams :: CompressParams Source #

The default set of parameters for compression. This is typically used with the `compressWith` function with specific parameters overridden.

data DecompressParams Source #

The full set of parameters for decompression. The defaults are `defaultDecompressParams`.

The `decompressBufferSize` is the size of the first output buffer, containing the uncompressed data. If you know an exact or approximate upper bound on the size of the decompressed data then setting this parameter can save memory. The default decompression output buffer size is `32k`. If your estimate is wrong it does not matter too much, the default buffer size will be used for the remaining chunks.

One particular use case for setting the `decompressBufferSize` is if you know the exact size of the decompressed data and want to produce a strict `ByteString`. The compression and decompression functions use lazy `ByteString`s but if you set the `decompressBufferSize` correctly then you can generate a lazy `ByteString` with exactly one chunk, which can be converted to a strict `ByteString` in `O(1)` time using ``concat` . `toChunks``.

Constructors

DecompressParams |

Fields

- decompressMemoryLevel :: MemoryLevel
- decompressBufferSize :: Int

#### Instances

Instances details

Show DecompressParams Source # |
Instance details Defined in Codec.Compression.BZip.Internal Methods showsPrec :: Int -> DecompressParams -> ShowS Source # show :: DecompressParams -> String Source # showList :: [DecompressParams] -> ShowS Source #

defaultDecompressParams :: DecompressParams Source #

The default set of parameters for decompression. This is typically used with the `compressWith` function with specific parameters overridden.

data BlockSize Source #

The block size affects both the compression ratio achieved, and the amount of memory needed for compression and decompression.

``BlockSize` 1` through ``BlockSize` 9` specify the block size to be 100,000 bytes through 900,000 bytes respectively. The default is to use the maximum block size.

Larger block sizes give rapidly diminishing marginal returns. Most of the compression comes from the first two or three hundred k of block size, a fact worth bearing in mind when using bzip2 on small machines. It is also important to appreciate that the decompression memory requirement is set at compression time by the choice of block size.

- In general, try and use the largest block size memory constraints allow, since that maximises the compression achieved.
- Compression and decompression speed are virtually unaffected by block size.

Another significant point applies to files which fit in a single block - that means most files you'd encounter using a large block size. The amount of real memory touched is proportional to the size of the file, since the file is smaller than a block. For example, compressing a file 20,000 bytes long with the flag ``BlockSize` 9` will cause the compressor to allocate around 7600k of memory, but only touch 400k + 20000 * 8 = 560 kbytes of it. Similarly, the decompressor will allocate 3700k but only touch 100k + 20000 * 4 = 180 kbytes.

Constructors

DefaultBlockSize | The default block size is also the maximum.
BlockSize Int | A specific block size between 1 and 9.

#### Instances

Instances details

Show BlockSize Source # |
Instance details Defined in Codec.Compression.BZip.Stream Methods showsPrec :: Int -> BlockSize -> ShowS Source # show :: BlockSize -> String Source # showList :: [BlockSize] -> ShowS Source #

data WorkFactor Source #

The `WorkFactor` parameter controls how the compression phase behaves when presented with worst case, highly repetitive, input data. If compression runs into difficulties caused by repetitive data, the library switches from the standard sorting algorithm to a fallback algorithm. The fallback is slower than the standard algorithm by perhaps a factor of three, but always behaves reasonably, no matter how bad the input.

Lower values of `WorkFactor` reduce the amount of effort the standard algorithm will expend before resorting to the fallback. You should set this parameter carefully; too low, and many inputs will be handled by the fallback algorithm and so compress rather slowly, too high, and your average-to-worst case compression times can become very large. The default value of 30 gives reasonable behaviour over a wide range of circumstances.

- Note that the compressed output generated is the same regardless of whether or not the fallback algorithm is used.

Constructors

DefaultWorkFactor | The default work factor is 30.
WorkFactor Int | Allowable values range from 1 to 250 inclusive.

#### Instances

Instances details

Show WorkFactor Source # |
Instance details Defined in Codec.Compression.BZip.Stream Methods showsPrec :: Int -> WorkFactor -> ShowS Source # show :: WorkFactor -> String Source # showList :: [WorkFactor] -> ShowS Source #

data MemoryLevel Source #

For files compressed with the default 900k block size, decompression will require about 3700k to decompress. To support decompression of any file in less than 4Mb there is the option to decompress using approximately half this amount of memory, about 2300k. Decompression speed is also halved, so you should use this option only where necessary.

Constructors

DefaultMemoryLevel | The default.
MinMemoryLevel | Use minimum memory during decompression. This halves the memory needed but also halves the decompression speed.

#### Instances

Instances details

Show MemoryLevel Source # |
Instance details Defined in Codec.Compression.BZip.Stream Methods showsPrec :: Int -> MemoryLevel -> ShowS Source # show :: MemoryLevel -> String Source # showList :: [MemoryLevel] -> ShowS Source #